/*
 * Copyright © 2012 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Alan Griffiths <alan@octopull.co.uk>
 */

#include "mir_client/make_rpc_channel.h"
#include "mir_socket_rpc_channel.h"

namespace mcl = mir::client;

std::shared_ptr<google::protobuf::RpcChannel>
mcl::make_rpc_channel(std::string const& name, std::shared_ptr<Logger> const& log)
{
    return std::make_shared<MirSocketRpcChannel>(name, log);

}

